import { Controller } from "@hotwired/stimulus"

function hide(elem, hide) {
  if (hide) {
    elem.classList.add("hidden");
  } else {
    elem.classList.remove("hidden");
  }
}

export default class extends Controller {
  static targets = ["candidates"];

  connect() {
    const uid = document.body.dataset.loggedinUid;
    const isCandidate = this.candidatesTarget.querySelector(`a.candidate[data-candidate-uid="${uid}"]`);

    this.element.querySelectorAll('.only-loggedin').forEach(el => {
      hide(el, !uid);
    });
    this.element.querySelectorAll('.only-loggedout').forEach(el => {
      hide(el, uid);
    });
    this.element.querySelectorAll('.only-candidate').forEach(el => {
      hide(el, !isCandidate);
    });
    this.element.querySelectorAll('.only-no-candidate').forEach(el => {
      hide(el, isCandidate);
    });
  }

  submitWithPrompt(event) {
    event.preventDefault();

    const reason = prompt(event.target.dataset.prompt);
    if (reason !== null && reason.trim() !== "") {
      const input = document.createElement("input");
      input.type = "hidden";
      input.name = "note";
      input.value = reason;
      const form = event.target.closest("form");
      form.appendChild(input);
      form.requestSubmit();
    }
  }
}
